=== modified file 'lib/DBServer/MySQL/MySQLd.pm'
--- lib/DBServer/MySQL/MySQLd.pm	2010-05-12 13:00:28 +0000
+++ lib/DBServer/MySQL/MySQLd.pm	2010-05-19 13:34:34 +0000
@@ -48,6 +48,7 @@
 use constant MYSQLD_VALGRIND => 16;
 use constant MYSQLD_VALGRIND_OPTIONS => 17;
 use constant MYSQLD_VERSION => 18;
+use constant MYSQLD_DUMPER => 19;
 
 use constant MYSQLD_PID_FILE => "mysql.pid";
 use constant MYSQLD_LOG_FILE => "mysql.err";
@@ -91,6 +92,10 @@
                                           osWindows()?"mysqld.exe":"mysqld");
     $self->[MYSQLD_BOOT_SQL] = [];
 
+    $self->[MYSQLD_DUMPER] = $self->_find([$self->basedir],
+                                          osWindows()?["client/Debug","client/RelWithDebugInfo","client/Release"]:["client","bin"],
+                                          osWindows()?"mysqldump.exe":"mysqldump");
+
 
     ## Check for CMakestuff to get hold of source dir:
 
@@ -535,3 +540,18 @@
 
     return $v < $b;
 }
+
+
+sub dumper {
+    return $_[0]->[MYSQLD_DUMPER];
+}
+
+sub dumpdb {
+    my ($self,$database, $file) = @_;
+    say("Dumping Mysql server ".$self->version." on port ".$self->port);
+    my $dump_result = system('"'.$self->dumper.
+                             "\" --hex-blob --no-tablespaces --skip-triggers --compact --order-by-primary --skip-extended-insert --no-create-info --host=127.0.0.1 --port=".
+                             $self->port.
+                             " --user=root $database | sort > $file");
+    return $dump_result;
+}

=== modified file 'runall-new.pl'
--- runall-new.pl	2010-04-22 12:44:43 +0000
+++ runall-new.pl	2010-05-19 13:34:34 +0000
@@ -363,20 +363,13 @@
     if ($rpl_mode ne '') {
         $rplsrv->waitForSlaveSync;
     }
-	my @dump_ports = ($ports[0]);
-	if ($rpl_mode) {
-		push @dump_ports, $ports[1];
-	} elsif (defined $basedirs[1]) {
-		push @dump_ports, $ports[1];
-	}
-    
-	my @dump_files;
-    
-	foreach my $i (0..$#dump_ports) {
-		say("Dumping server on port $dump_ports[$i]...");
+
+    my @dump_files;
+    
+	foreach my $i (0..$#server) {
 		$dump_files[$i] = tmpdir()."/server_".$$."_".$i.".dump";
         
-		my $dump_result = system("\"$client_basedir/mysqldump\" --hex-blob --no-tablespaces --skip-triggers --compact --order-by-primary --skip-extended-insert --no-create-info --host=127.0.0.1 --port=$dump_ports[$i] --user=root $database | sort > $dump_files[$i]");
+		my $dump_result = $server[$i]->dumpdb($database,$dump_files[$i]);
 		exit_test($dump_result >> 8) if $dump_result > 0;
 	}
     

